package com.zeal.gov.kar.pwmt.activities;

import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import com.zeal.gov.kar.pwmt.common.utils.AppUserDetails;
import com.zeal.gov.kar.pwmt.common.utils.CreateToastMessage;
import com.zeal.gov.kar.pwmt.daos.BaseService;
import com.zeal.gov.kar.pwmt.models.Work_Component_UpdateStatus;
import com.zeal.gov.kar.pwmt.models.Work_Component_Updations_Photo;
import com.zeal.gov.kar.pwmt.models.Work_Components;
import com.zeal.gov.kar.pwmt.models.Work_Coordinates;

import android.app.Activity;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.DatePickerDialog.OnDateSetListener;
import android.content.Context;
import android.content.Intent;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Matrix;
import android.graphics.Paint;
import android.graphics.Paint.Align;
import android.graphics.Paint.Style;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.ExifInterface;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.provider.MediaStore;
import android.text.Editable;
import android.text.TextUtils;
import android.text.TextWatcher;
import android.text.TextUtils.TruncateAt;
import android.text.method.ScrollingMovementMethod;
import android.util.Base64;
import android.util.Log;

import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnKeyListener;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.AutoCompleteTextView.Validator;
import android.widget.Button;
import android.widget.DatePicker;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

public class WorkUpdatingActivity extends Activity implements OnClickListener,OnKeyListener,LocationListener{
	private Spinner spnStatus,spnSubStage;
	private Button btnSave,btnCreateIssue,btnCaptureImage;
	private EditText edtActualStartDate,edtActualEndDate,edtFromDist,edtToDist;
	private TextView tvWorkname,tvGroupName,tvChainageName,tvDistance,tvDesc;
	private HashMap<String, Integer> hmStatusSpinner,hmSubStage;
	private List<String> lstStatusNames,lstSubstage;
	Work_Components wc;
	private String todistance,fromdistance;
	int latestWorkComponentUpdationId = 0;
	static final int DATE_DIALOG_ID = 2;
	static final int DATE_DIALOG_ID1 = 3;
	public static final int PICTURE_RESULT = 1;
	Uri imageUri;
	LocationManager locationManager;
	private Location CurrentLocation;
	String StrDateSelected,strDistance;
	LinearLayout subStageLayout,llStartEndDist;
	String workNameDesc,groupComponentName,chainageName,WorkDesc;
    HashMap<String, String> hmdates;
    private Location camLocation;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_workupdatinglayout);

		Intent intent = getIntent();
		wc = (Work_Components) intent.getSerializableExtra("Work_Components");
		workNameDesc = intent.getStringExtra("WorkNameDesc");
		groupComponentName = intent.getStringExtra("GroupComponentName");
		chainageName = intent.getStringExtra("ChainageName");
		WorkDesc = intent.getStringExtra("WorkDesc");
		locationManager = (LocationManager) getApplicationContext()
				.getSystemService(LOCATION_SERVICE);
		locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
				1000, 5, this);
		spnStatus = (Spinner) findViewById(R.id.spnStatus);
		spnSubStage = (Spinner) findViewById(R.id.spnsubStages);
		subStageLayout = (LinearLayout) findViewById(R.id.subStageLayout);
		edtActualStartDate = (EditText) findViewById(R.id.edtStartDate);
		edtActualEndDate = (EditText) findViewById(R.id.edtEndDate);
		edtFromDist = (EditText) findViewById(R.id.edtStartCoor);
		edtToDist = (EditText) findViewById(R.id.edtEndCoor);
		tvDesc = (TextView)findViewById(R.id.tvComponent);
		tvWorkname = (TextView) findViewById(R.id.tvWorkName);
		tvGroupName = (TextView) findViewById(R.id.tvGroupName);
		tvChainageName = (TextView) findViewById(R.id.tvChainageName);
		tvDistance = (TextView)findViewById(R.id.tvDistance);
		btnCaptureImage = (Button) findViewById(R.id.btnCaptureImage);
		btnCreateIssue = (Button) findViewById(R.id.btnCreateissue);
		llStartEndDist = (LinearLayout) findViewById(R.id.llStartEnd);
		btnSave = (Button) findViewById(R.id.btnSave);
		hmdates = new HashMap<String, String>();
		tvChainageName.setText(chainageName);
		tvGroupName.setText(groupComponentName);
		
		if(wc.getComponentId() == 3 && wc.getSubComponentId() !=12){
			llStartEndDist.setVisibility(View.GONE);
			tvDistance.setVisibility(View.GONE);
		}
		
		tvWorkname.setText(workNameDesc);
		tvWorkname.setSingleLine(false);
		tvDesc.setText(WorkDesc);
		btnCreateIssue.setVisibility(View.GONE);
		subStageLayout.setVisibility(View.GONE);
		btnCreateIssue.setEnabled(false);
		btnCaptureImage.setEnabled(false);
		Intent in = getIntent();
        hmdates = (HashMap<String, String>) in.getSerializableExtra("hashmap");
        fromdistance = hmdates.get("fromdistance");
        todistance = hmdates.get("Todistance");
		
		
       
		btnCaptureImage.setOnClickListener(this);
		btnCreateIssue.setOnClickListener(this);
		btnSave.setOnClickListener(this);

		bindWorkToStatusSpinner();
		bindWorkToSubStage();

		edtActualStartDate.setOnClickListener(this);
		edtActualEndDate.setOnClickListener(this);

		edtToDist.addTextChangedListener(new TextWatcher() {

			@Override
			public void onTextChanged(CharSequence s, int start, int before, int count) {
				// TODO Auto-generated method stub
//				if (spnMeasurementUnit.getSelectedItemPosition() == )
					if(count>=1){
						
						if(!edtFromDist.getText().toString().isEmpty() ){
							if(edtToDist.getText().toString().startsWith(".")||edtFromDist.getText().toString().startsWith(".")){
								BigDecimal toDist = new BigDecimal("0"+edtToDist.getText().toString());
								BigDecimal fromDist = new BigDecimal("0"+edtFromDist.getText().toString());
								BigDecimal value = toDist.subtract(fromDist);
									tvDistance.setText("Distance: "+value);	
								
							}else{
								BigDecimal toDist = new BigDecimal(edtToDist.getText().toString());
								BigDecimal fromDist = new BigDecimal(edtFromDist.getText().toString());
								BigDecimal value = toDist.subtract(fromDist);
								tvDistance.setText("Distance: "+value);
								}
						}
							
						
					}

			}

			@Override
			public void beforeTextChanged(CharSequence s, int start, int count,
					int after) {
				// TODO Auto-generated method stub
				
				
			}

			@Override
			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
				
			}
		});
		
		edtFromDist.addTextChangedListener(new TextWatcher() {

			@Override
			public void onTextChanged(CharSequence s, int start, int before, int count) {
				// TODO Auto-generated method stub
//				if (spnMeasurementUnit.getSelectedItemPosition() == )
					if(count>=1){
						
						if(!edtToDist.getText().toString().isEmpty()){
							if(edtFromDist.getText().toString().startsWith(".")||edtToDist.getText().toString().startsWith(".")){
								BigDecimal toDist = new BigDecimal("0"+edtToDist.getText().toString());
								BigDecimal fromDist = new BigDecimal("0"+edtFromDist.getText().toString());
								BigDecimal value = toDist.subtract(fromDist);
								
									tvDistance.setText("Distance: "+value);	
								
							}
							else{
								BigDecimal toDist = new BigDecimal(edtToDist.getText().toString());
								BigDecimal fromDist = new BigDecimal(edtFromDist.getText().toString());
								BigDecimal value = toDist.subtract(fromDist);
								tvDistance.setText("Distance: "+value);
								}
						}
					}

			}

			@Override
			public void beforeTextChanged(CharSequence s, int start, int count,
					int after) {
				// TODO Auto-generated method stub

			}

			@Override
			public void afterTextChanged(Editable s) {
				// TODO Auto-generated method stub
				
				
			
			}
		});
		  
	
		
		spnStatus.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> element, View arg1,
					int pos, long arg3) {
				// TODO Auto-generated method stub  BottleNeck
				if(pos>0){
					String selectedStatus = element.getItemAtPosition(pos).toString();
					/*if(selectedStatus.equalsIgnoreCase("Untackled")){
						if(btnCreateIssue.getVisibility() == View.VISIBLE){
							btnCreateIssue.setVisibility(View.GONE);
						}
						if(subStageLayout.getVisibility() == View.VISIBLE){
							subStageLayout.setVisibility(View.GONE);
						}
					}else*/
					if(selectedStatus.equalsIgnoreCase("Under Progress")){
						if(btnCreateIssue.getVisibility() == View.VISIBLE){
							btnCreateIssue.setVisibility(View.GONE);
						}
						if(wc.getComponentId() == 3){
							subStageLayout .setVisibility(View.VISIBLE);
						}
					}else if(selectedStatus.equalsIgnoreCase("BottleNeck")){
						btnCreateIssue.setVisibility(View.VISIBLE);
						if(subStageLayout.getVisibility() == View.VISIBLE){
							subStageLayout.setVisibility(View.GONE);
						}
					}else if(selectedStatus.equalsIgnoreCase("Completed")){
						if(btnCreateIssue.getVisibility() == View.VISIBLE){
							btnCreateIssue.setVisibility(View.GONE);
						}
						if(subStageLayout.getVisibility() == View.VISIBLE){
							subStageLayout.setVisibility(View.GONE);
						}
					}
				}
			}

			@Override
			public void onNothingSelected(AdapterView<?> arg0) {
				// TODO Auto-generated method stub

			}
		});
		 CurrentLocation = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);

	}

	@SuppressWarnings("unchecked")
	private void bindWorkToSubStage() {
		// TODO Auto-generated method stub
		BaseService baseService = new BaseService(WorkUpdatingActivity.this);
		HashMap<String, Object> hm = baseService.getDataToSubStageSpinner();
		lstSubstage = new ArrayList<String>();
		lstSubstage.add("Select status");
		lstSubstage.addAll((List<String>) hm.get("List"));
		hmSubStage = (HashMap<String, Integer>) hm.get("Hashmap");
		hmSubStage.put("Select status", 0);
		spnSubStage.setAdapter(new ArrayAdapter<String>(WorkUpdatingActivity.this, R.layout.textview, lstSubstage));
	}

	@SuppressWarnings("unchecked")
	private void bindWorkToStatusSpinner() {
		// TODO Auto-generated method stub
		BaseService baseService = new BaseService(WorkUpdatingActivity.this);
		HashMap<String, Object> hm = baseService.getDataToStatusSpinner();
		lstStatusNames = new ArrayList<String>();
		lstStatusNames.add("Select status");
		lstStatusNames.addAll((List<String>) hm.get("List"));
		hmStatusSpinner = (HashMap<String, Integer>) hm.get("Hashmap");
		hmStatusSpinner.put("Select status", 0);
		spnStatus.setAdapter(new ArrayAdapter<String>(WorkUpdatingActivity.this, R.layout.textview, lstStatusNames));
		
	}

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.btnCreateissue:
			Intent intent = new Intent(WorkUpdatingActivity.this, CreateissueActivity.class);
			intent.putExtra("WorkId", String.valueOf(wc.getWorkId()));
			intent.putExtra("WorkComponentUpdationId",  String.valueOf(latestWorkComponentUpdationId));
			startActivity(intent);
			break;
		case R.id.btnCaptureImage:
			camLocation  = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
//			if(camLocation != null){
//				if(camLocation.hasAccuracy()){
//					if(camLocation.getAccuracy() < 20.0){
//						BaseService baseService = new BaseService(WorkUpdatingActivity.this);
//						List<Work_Coordinates> lstWCUP = baseService.getWorkCoordinatesList(String.valueOf(wc.getWorkId()));
//						if(lstWCUP.size() > 0){
//							if(canProceedForPhotoCapturing(lstWCUP,camLocation,wc.getComponentId())){

								String root = Environment.getExternalStorageDirectory().toString();
								File imageFileFolder = new File(root + "/PWMTPhotos");
								if(!imageFileFolder.exists()){
									imageFileFolder.mkdirs();
								}
								File imageFile = new File(imageFileFolder,"PWMT-"+System.currentTimeMillis()+".jpg");
								imageUri = Uri.fromFile(imageFile);

								Log.e("TAG", imageUri.getPath());
								Intent cameraIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
								cameraIntent.putExtra(MediaStore.EXTRA_OUTPUT,imageUri);
								startActivityForResult(cameraIntent, PICTURE_RESULT);
							/*}else{
								CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "You are not in work section measured during capturing coordinates");
							}
						}else{
							CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "No coordinates been captured to take photos");
						}*/
					/*}else{
						CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "Current location is not accurate please wait");
					}
				}else{
					CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "Current location is not accurate please wait");
				}
			}else{
//				if(CurrentLocation != null){
//					String root = Environment.getExternalStorageDirectory().toString();
//					File imageFileFolder = new File(root + "/PWMTPhotos");
//					if(!imageFileFolder.exists()){
//						imageFileFolder.mkdirs();
//					}
//					File imageFile = new File(imageFileFolder,"PWMT-"+System.currentTimeMillis()+".jpg");
//					imageUri = Uri.fromFile(imageFile);
//
//					Log.e("TAG", imageUri.getPath());
//					Intent cameraIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
//					cameraIntent.putExtra(MediaStore.EXTRA_OUTPUT,imageUri);
//					startActivityForResult(cameraIntent, PICTURE_RESULT);
//				}else{
					CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "Please wait for the GPS to initialize");
//				}
			}*/
			break;
		case R.id.btnSave:
			if(wc.getComponentId() == 3 && wc.getSubComponentId() != 12){
				if(spnStatus.getSelectedItemPosition()>0){
					DateFormat dateFormat = android.text.format.DateFormat.getDateFormat(getApplicationContext());
					BaseService baseService = new BaseService(WorkUpdatingActivity.this);
					latestWorkComponentUpdationId = baseService.getLatestWorkComponentUpdationId();
					Work_Component_UpdateStatus wcu = new Work_Component_UpdateStatus();
					wcu.setCreatedBy(AppUserDetails.getUsername());
					//					wcu.setCreatedOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
					wcu.setCreatedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
//					wcu.setFromKM(Double.parseDouble(edtFromDist.getText().toString()));
					wcu.setLattitude("");
					wcu.setLongitude("");
					wcu.setModifiedBy(AppUserDetails.getUsername());
					//					wcu.setModifiedOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
					wcu.setModifiedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
					wcu.setSubComponentStage(hmSubStage.get(spnSubStage.getSelectedItem().toString()));
//					wcu.setToKM(Double.parseDouble(edtToDist.getText().toString()));
					wcu.setWorkComponentId(wc.getWorkComponentId());
					int latId = latestWorkComponentUpdationId;
					wcu.setWorkComponentUpdationId(++latId);
					wcu.setWorkId(wc.getWorkId());
					//					wcu.setWorkStatusAsOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
					wcu.setWorkStatusAsOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
					wcu.setWorkStatusDescription(spnStatus.getSelectedItem().toString());
					wcu.setWorkStatusType(hmStatusSpinner.get(spnStatus.getSelectedItem().toString()));
					//					wcu.setWorkStatusUpdatedOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
					wcu.setWorkStatusUpdatedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
					wcu.setActualStartDate(edtActualStartDate.getText().toString());
					wcu.setActualEndDate(edtActualEndDate.getText().toString());
					long insertvalue = baseService.insertIntoWorkComponentUpdationStatusWithXMLIdNULL(wcu);
					if(insertvalue >0){
						btnCreateIssue.setEnabled(true);
						btnCaptureImage.setEnabled(true);
						latestWorkComponentUpdationId = baseService.getLatestWorkComponentUpdationId();
						CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "Successfully saved");
					}
				}
				else{
					Toast.makeText(WorkUpdatingActivity.this,"Please select status",Toast.LENGTH_LONG).show();
				}				
			}else{
				boolean fromvalue=false;
				boolean toValue = false;
				if(!edtFromDist.getText().toString().isEmpty()){
					String str = edtFromDist.getText().toString();
					if(str.startsWith(".")){
						str = 0+str;
					}
					BigDecimal edt = new BigDecimal(str);
					BigDecimal fromdecimal = new BigDecimal(fromdistance);
					int comp = edt.compareTo(fromdecimal);
					if(comp == -1){
						fromvalue = true;
						Toast.makeText(WorkUpdatingActivity.this," The given fromdistance is greater than actual fromdistance:"+fromdistance,Toast.LENGTH_LONG).show();
					}

				}else{
					fromvalue = true;
				}
				if(!edtToDist.getText().toString().isEmpty()){
					String str = edtToDist.getText().toString();
					if(str.contains(".")){
						str = 0+str;
					}
					BigDecimal edt = new BigDecimal(str);
					BigDecimal distance = new BigDecimal(todistance);
					int big = edt.compareTo(distance);
					if(big == 1){
						toValue  = true;
						Toast.makeText(WorkUpdatingActivity.this, "The given todistance is greater then actual todistance:"+todistance, Toast.LENGTH_LONG).show();

					}

				}
				else{
					toValue= true;
				}
				if(!(toValue || fromvalue)){
					if(spnStatus.getSelectedItemPosition()>0){
						DateFormat dateFormat = android.text.format.DateFormat.getDateFormat(getApplicationContext());
						BaseService baseService = new BaseService(WorkUpdatingActivity.this);
						latestWorkComponentUpdationId = baseService.getLatestWorkComponentUpdationId();
						Work_Component_UpdateStatus wcu = new Work_Component_UpdateStatus();
						wcu.setCreatedBy(AppUserDetails.getUsername());
						//					wcu.setCreatedOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
						wcu.setCreatedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
						wcu.setFromKM(Double.parseDouble(edtFromDist.getText().toString()));
						wcu.setLattitude("");
						wcu.setLongitude("");
						wcu.setModifiedBy(AppUserDetails.getUsername());
						//					wcu.setModifiedOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
						wcu.setModifiedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
						wcu.setSubComponentStage(hmSubStage.get(spnSubStage.getSelectedItem().toString()));
						wcu.setToKM(Double.parseDouble(edtToDist.getText().toString()));
						wcu.setWorkComponentId(wc.getWorkComponentId());
						int latId = latestWorkComponentUpdationId;
						wcu.setWorkComponentUpdationId(++latId);
						wcu.setWorkId(wc.getWorkId());
						//					wcu.setWorkStatusAsOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
						wcu.setWorkStatusAsOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
						wcu.setWorkStatusDescription(spnStatus.getSelectedItem().toString());
						wcu.setWorkStatusType(hmStatusSpinner.get(spnStatus.getSelectedItem().toString()));
						//					wcu.setWorkStatusUpdatedOn(dateFormat.format(new Date(Calendar.getInstance().getTime().toString())));
						wcu.setWorkStatusUpdatedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
						wcu.setActualStartDate(edtActualStartDate.getText().toString());
						wcu.setActualEndDate(edtActualEndDate.getText().toString());
						long insertvalue = baseService.insertIntoWorkComponentUpdationStatusWithXMLIdNULL(wcu);
						if(insertvalue >0){
							btnCreateIssue.setEnabled(true);
							btnCaptureImage.setEnabled(true);
							latestWorkComponentUpdationId = baseService.getLatestWorkComponentUpdationId();
							CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "Successfully saved");
						}
					}
					else{
						Toast.makeText(WorkUpdatingActivity.this,"Please select status",Toast.LENGTH_LONG).show();
					}
				}else{
					Toast.makeText(WorkUpdatingActivity.this,"Please check to and from distance",Toast.LENGTH_LONG).show();
				}
			}
			break;

		case R.id.edtStartDate:
			showDialog(DATE_DIALOG_ID);
			
			break;
		case R.id.edtEndDate:
			showDialog(DATE_DIALOG_ID1);
			break;
		default:
			break;
		}

	}

	private boolean canProceedForPhotoCapturing(
			List<Work_Coordinates> lstWCUP, Location camLocation2, int compId) {
		// TODO Auto-generated method stub
		CurrentLocation = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
		if(compId == 1 || compId == 2){
			for(Work_Coordinates wcoor:lstWCUP){
				if(CurrentLocation != null){
					CurrentLocation.setLatitude(Double.parseDouble(wcoor.getLatitude()));
					CurrentLocation.setLongitude(Double.parseDouble(wcoor.getLongitude()));
					if(camLocation2.distanceTo(CurrentLocation) < 100){
						return true;
					}
				}else{
					return false;
				}
			}
		}else{
			//code for if photo capturing is for structures..
			double locationkm = wc.getLocationKM()*1000;
			double fromKM  = Double.parseDouble(fromdistance)*1000;
			double diffDist = locationkm - fromKM;
			double dist = 0.0;
			/*for(Work_Coordinates wcoor:lstWCUP){
				if(CurrentLocation != null){
					CurrentLocation.setLatitude(Double.parseDouble(wcoor.getLatitude()));
					CurrentLocation.setLongitude(Double.parseDouble(wcoor.getLongitude()));
					
					if(camLocation2.distanceTo(CurrentLocation) < 100){
						return true;
					}
				}else{
					return false;
				}
			}*/
			List<Work_Coordinates> lstCheckingCoor = new ArrayList<Work_Coordinates>();
			Location location1 = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
			Location location2 = locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
			for(int itr = 0 ; itr<lstWCUP.size() ; itr++){
				if(location1 != null){
					if(itr+1 != lstWCUP.size()){
						Work_Coordinates wcoor1 = lstWCUP.get(itr);
						Work_Coordinates wcoor2 = lstWCUP.get(itr + 1);
						location1.setLatitude(Double.parseDouble(wcoor1.getLatitude()));
						location1.setLongitude(Double.parseDouble(wcoor1.getLongitude()));
						location2.setLatitude(Double.parseDouble(wcoor2.getLatitude()));
						location2.setLongitude(Double.parseDouble(wcoor2.getLongitude()));
						dist = dist +  location1.distanceTo(location2);
						if((locationkm-dist) <= 100 || (locationkm +100 - dist) <= 100 ){
							lstCheckingCoor.add(wcoor1);
//							return true;
						}
					}
				}
			}
			
			for(Work_Coordinates wcoor1:lstCheckingCoor){
				if(CurrentLocation != null){
					CurrentLocation.setLatitude(Double.parseDouble(wcoor1.getLatitude()));
					CurrentLocation.setLongitude(Double.parseDouble(wcoor1.getLongitude()));
					if(camLocation2.distanceTo(CurrentLocation) < 100){
						return true;
					}
				}else{
					return false;
				}
			}
		}
		
		return false;
	}

	@SuppressWarnings("hiding")
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		super.onActivityResult(requestCode, resultCode, data);
		Log.e("imageUri","HELLOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO");
		FileOutputStream fileOutputStream = null;
		if (requestCode == PICTURE_RESULT && resultCode == Activity.RESULT_OK) {

			if(data != null && data.getData()!=null){
				imageUri = data.getData();
				Log.e("imageUri",imageUri.getPath());
			}
			try {
				Bitmap bitmap = decodeUri(imageUri);
				//Bitmap capturedImage=timestampItAndSave(bitmap);
				/*String ipath = imageUri.getPath().replace("/mnt/sdcard/PWMTPhotos/PWMT-", "");
				String url="/sdcard/PWMTPhotos/"+"PWMT-"+ipath;
//				String root = Environment.getExternalStorageDirectory().toString();//for nexus 4
//				String ipath = imageUri.getPath().replace(root+"/PWMTPhotos/PWMT-", "");//for nexus 4
//				String url="/sdcard/PWMTPhotos/"+"PWMT-"+ipath;//for nexus 4

				fileOutputStream = new FileOutputStream(url);
				BufferedOutputStream bos = new BufferedOutputStream(fileOutputStream, 8129);
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				bitmap.compress(Bitmap.CompressFormat.JPEG, 100, baos);
				byte[] b = baos.toByteArray();
				StoreByteImage(b);
			//	capturedImage.compress(Bitmap.CompressFormat.JPEG, 100, bos);
				insertIntoComponentUpdationsPhoto(imageUri.getPath());
				bos.flush();
				bos.close();*/
				
				if(bitmap != null){
					ByteArrayOutputStream baos = new ByteArrayOutputStream();
					bitmap.compress(Bitmap.CompressFormat.JPEG, 100, baos);
					byte[] b = baos.toByteArray();
					bitmap = StoreByteImage(b);
				}
				
				insertIntoComponentUpdationsPhoto(imageUri.getPath());
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	private void insertIntoComponentUpdationsPhoto(String path) {
		// TODO Auto-generated method stub
		DateFormat dateFormat = android.text.format.DateFormat.getDateFormat(getApplicationContext());
		BaseService baseService = new BaseService(WorkUpdatingActivity.this);
		int lastPhotoId = baseService.getLatestWorkComponentUpdationPhotoId(String.valueOf(wc.getWorkId()),String.valueOf(latestWorkComponentUpdationId));
		Work_Component_Updations_Photo wcup = new Work_Component_Updations_Photo();
		wcup.setCreatedBy(AppUserDetails.getUsername());
		wcup.setCreatedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
		/*if(camLocation != null){
			wcup.setLattitude(String.valueOf(camLocation.getLatitude()));
			wcup.setLongtitude(String.valueOf(camLocation.getLongitude()));
		}else{
			if(CurrentLocation != null){
				wcup.setLattitude(String.valueOf(CurrentLocation.getLatitude()));
				wcup.setLongtitude(String.valueOf(CurrentLocation.getLongitude()));
			}
		}*/
		
		wcup.setModifiedBy(AppUserDetails.getUsername());
		wcup.setModifiedOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
		wcup.setPhoto(path);
		wcup.setPhotoId(++lastPhotoId);
		wcup.setPhotoTakenOn(new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())));
		wcup.setWorkComponentUpdationId(latestWorkComponentUpdationId);
		wcup.setWorkId(wc.getWorkId());
		long insertVal = baseService.insertIntoComponentUpdationsPhoto(wcup);
		if(insertVal >0 ){
			CreateToastMessage.showToastMessage(WorkUpdatingActivity.this, "Image saved");
		}
	}

	private Bitmap decodeUri(Uri selectedImage) throws FileNotFoundException {
		BitmapFactory.Options o = new BitmapFactory.Options();
		o.inJustDecodeBounds = true;
		BitmapFactory.decodeStream(
				getContentResolver().openInputStream(selectedImage), null, o);

		final int REQUIRED_SIZE = 500;

		int width_tmp = o.outWidth, height_tmp = o.outHeight;
		int scale = 1;
		while (true) {
			if (width_tmp / 2 < REQUIRED_SIZE || height_tmp / 2 < REQUIRED_SIZE) {
				break;
			}
			width_tmp /= 2;
			height_tmp /= 2;
			scale *= 2;
		}

		BitmapFactory.Options o2 = new BitmapFactory.Options();
		o2.inSampleSize = scale;
		return BitmapFactory.decodeStream(
				getContentResolver().openInputStream(selectedImage), null, o2);
	}

	@Override
	protected Dialog onCreateDialog(int id) {
		Calendar c = Calendar.getInstance();
		int year = c.get(Calendar.YEAR);
		int month = c.get(Calendar.MONTH);
		int day = c.get(Calendar.DAY_OF_MONTH);
		switch (id) {
		case DATE_DIALOG_ID:
			return new DatePickerDialog(this, dairyRegDate, year, month, day);

		case DATE_DIALOG_ID1:
			return new DatePickerDialog(this, dairyRegDate1, year, month, day);
		}

		return null;
	}

	OnDateSetListener dairyRegDate = new DatePickerDialog.OnDateSetListener() {

		public void onDateSet(DatePicker view, int year, int monthOfYear,
				int dayOfMonth) {

			StrDateSelected = String.valueOf(dayOfMonth) + "/"
					+ String.valueOf(monthOfYear + 1) + "/"
					+ String.valueOf(year);
			edtActualStartDate.setText(StrDateSelected);
		}

	};

	OnDateSetListener dairyRegDate1 = new DatePickerDialog.OnDateSetListener() {

		public void onDateSet(DatePicker view, int year, int monthOfYear,
				int dayOfMonth) {

			StrDateSelected = String.valueOf(dayOfMonth) + "/"
					+ String.valueOf(monthOfYear + 1) + "/"
					+ String.valueOf(year);
			edtActualEndDate.setText(StrDateSelected);
		}

	};
	@Override
	public boolean onKey(View v, int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		switch (v.getId()) {
		case R.id.edtStartCoor:
			if(keyCode == KeyEvent.KEYCODE_DEL){  
				if(!edtFromDist.getText().toString().isEmpty() ){
					if(edtToDist.getText().toString().startsWith(".")||edtFromDist.getText().toString().startsWith(".")){
						
							tvDistance.setText("Distance: "+String.valueOf(Double.valueOf("0"+edtToDist.getText().toString()) - Double.valueOf("0"+edtFromDist.getText().toString())));	
						
					}else{
						tvDistance.setText("Distance: "+String.valueOf(Double.valueOf(edtToDist.getText().toString()) - Double.valueOf(edtFromDist.getText().toString())));
						}
				}
			}
			break;
		case R.id.edtEndCoor:
			if(keyCode == KeyEvent.KEYCODE_DEL){ 
			if(!edtToDist.getText().toString().isEmpty()){
				if(edtFromDist.getText().toString().startsWith(".")||edtToDist.getText().toString().startsWith(".")){
					
						tvDistance.setText("Distance: "+String.valueOf(Double.valueOf("0"+edtToDist.getText().toString()) - Double.valueOf("0"+edtFromDist.getText().toString())));	
					
				}
				else{
					tvDistance.setText("Distance: "+String.valueOf(Double.valueOf(edtToDist.getText().toString()) - Double.valueOf(edtFromDist.getText().toString())));
					}
			}
			}
			break;
		default:
			break;
		}
		return false;
	}
public Bitmap timestampItAndSave(Bitmap toEdit){
		
		SimpleDateFormat sdate = new SimpleDateFormat("dd-MMM-yyyy hh:mm:ss a");
		String dateTime = new SimpleDateFormat( "dd/MM/yyyy hh:mm:ss:SS" ).format(new Date(System.currentTimeMillis())); 
		Bitmap canvasBitmap =toEdit.copy(Bitmap.Config.RGB_565, true);
		Canvas imageCanvas = new Canvas(canvasBitmap);
		Paint imagePaint = new Paint();
		imagePaint.setTextAlign(Align.CENTER);
		imagePaint.setTextSize(12f);
		imagePaint.setStyle(Style.FILL);
		imagePaint.setColor(Color.YELLOW);
		imageCanvas.drawText(dateTime, canvasBitmap.getWidth()/2, (canvasBitmap.getHeight()-5), imagePaint);
		//imageCanvas.drawText(dateTime, canvasBitmap.getWidth()/4, 20, imagePaint); 
		
		//imageCanvas.drawText(currentLocation.getLatitude() + ","+ currentLocation.getLongitude(), canvasBitmap.getWidth()/2, (canvasBitmap.getHeight()-5), imagePaint); 
		return canvasBitmap;
	}
	/*public  boolean StoreByteImage( byte[] imageData
			) {
		
		
		FileOutputStream fileOutputStream = null;
		try {
			String root = Environment.getExternalStorageDirectory().toString();

			
			BitmapFactory.Options options = new BitmapFactory.Options();
			options.inSampleSize = (int) 0.5;
			Bitmap myImage = BitmapFactory.decodeByteArray(imageData, 0,imageData.length, options);
			Bitmap capturedImage=timestampItAndSave(myImage);
			String ipath = imageUri.getPath().replace("/mnt/sdcard/PWMTPhotos/PWMT-", "");
			String url="/sdcard/PWMTPhotos/"+"PWMT-"+ipath;
//			String ipath = imageUri.getPath().replace(root+"/PWMTPhotos/PWMT-", "");//for nexus 4
//			String url="/sdcard/PWMTPhotos/"+"PWMT-"+ipath;//for nexus 4
			fileOutputStream = new FileOutputStream(url);
			BufferedOutputStream bos = new BufferedOutputStream(fileOutputStream, 8129);
			capturedImage.compress(Bitmap.CompressFormat.JPEG, 100, bos);
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			capturedImage.compress(Bitmap.CompressFormat.JPEG, 100, baos);
			//byte[] b = baos.toByteArray();
		       
			   
			
			bos.flush();
			bos.close();
		
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
 		return true;
	}*/
	public  Bitmap StoreByteImage( byte[] imageData
			) {

		Bitmap rotatedBitmap=null;
		Bitmap capturedImage = null;
		FileOutputStream fileOutputStream = null;
		try {
			String root = Environment.getExternalStorageDirectory().toString();
			BitmapFactory.Options options = new BitmapFactory.Options();
			options.inSampleSize = (int) 0.5;
			Bitmap myImage = BitmapFactory.decodeByteArray(imageData, 0,imageData.length, options);
			Matrix matrix = new Matrix();
			ExifInterface exifReader = null;

			try {
				exifReader = new ExifInterface(imageUri.getPath());
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}// Location of your image

			int orientation = exifReader.getAttributeInt(ExifInterface.TAG_ORIENTATION, ExifInterface.ORIENTATION_NORMAL);

			if (orientation ==ExifInterface.ORIENTATION_NORMAL) {

				// Do nothing. The original image is fine.
			} else if (orientation == ExifInterface.ORIENTATION_ROTATE_90) {

				matrix.postRotate(90);

			} else if (orientation == ExifInterface.ORIENTATION_ROTATE_180) {

				matrix.postRotate(180);

			} else if (orientation == ExifInterface.ORIENTATION_ROTATE_270) {

				matrix.postRotate(270);

			}
			//matrix.postRotate(90);
			//matrix.postRotate();
			//matrix.invert(matrix);
			rotatedBitmap = Bitmap.createBitmap(myImage, 0, 0, myImage.getWidth(), myImage.getHeight(), matrix, true);
			capturedImage=timestampItAndSave(rotatedBitmap);
//			String ipath = imageUri.getPath().replace("/mnt/sdcard/PWMTPhotos/PWMT-", "");
//			String url="/sdcard/PWMTPhotos/"+"PWMT-"+ipath;
			
			String ipath = imageUri.getPath().replace(root+"/PWMTPhotos/PWMT-", "");//for nexus 4
			String url="/sdcard/PWMTPhotos/"+"PWMT-"+ipath;//for nexus 4
			 			fileOutputStream = new FileOutputStream(url);
			 BufferedOutputStream bos = new BufferedOutputStream(fileOutputStream, 8129);
			 capturedImage.compress(Bitmap.CompressFormat.JPEG, 100, bos);
			 ByteArrayOutputStream baos = new ByteArrayOutputStream();
			capturedImage.compress(Bitmap.CompressFormat.JPEG, 100, baos);
			 //byte[] b = baos.toByteArray();



			 bos.flush();
			 bos.close();

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return capturedImage;
	}

	@Override
	public void onLocationChanged(Location location) {
		// TODO Auto-generated method stub
		camLocation = location;
		CurrentLocation = location;
	}

	@Override
	public void onProviderDisabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onProviderEnabled(String provider) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
		
	}
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
		if(locationManager != null){
		locationManager.removeUpdates(this);
		}
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		if(locationManager != null){
			locationManager.removeUpdates(this);
			}
	}
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();
		if(locationManager != null){
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
					1000, 5, this);
			}
	}
	
	
}
