
var MarkerType = {
		LTLine : 1,
		HTLine : 2,
		Transformer : 3,
		GreenIcon : 'GREEN',
		BlueIcon : 'BLUE',
		RedIcon : 'RED',
		YellowIcon : 'YELLOW'
}

var ge;
var gex;
google.load("earth", "1");
google.setOnLoadCallback(init);
var kmlObjects = { Estimated : null, Progress : null};


$(document).ready(function(){

	HideError();
	$('.markerImage').live('click', function () {
		// alert('hi');
		$(this).parent().parent().find('.imageLarge').attr('src', $(this).attr('src'));
	});

	$('.divClose').live('click', function () {
		if ($(this).parent().find('img').length <= 0) {
			return;
		}
		else {
			var areImagesVisible = $($(this).parent().find('img')[0]).is(':visible');
			if (!areImagesVisible) {
				$(this).parent().find('img').slideDown();
				$(this).find('.handler').remove();
				$(this).html('<img class="divClose" src="../Images/collapse.png">');
			}
			else {
				$(this).parent().find('img').slideUp();
				$(this).find('.handler').remove();
				$(this).html('<img class="divClose" src="../Images/expand.png">');
			}
		}
	});

});



function ExpanCollapse(object)
{
	if ($(object).parent().find('img').length <= 0) {
		return;
	}
	else {
		var areImagesVisible = $($(object).parent().find('img')[0]).is(':visible');
		if (!areImagesVisible) {
			$(object).parent().find('img').slideDown();
			$(object).find('.handler').remove();
			$(object).html('<img class="divClose" src="../Images/collapse.png">');
		}
		else {
			$(object).parent().find('img').slideUp();
			$(object).find('.handler').remove();
			$(object).html('<img class="divClose" src="../Images/expand.png">');
		}
	}
}

function LoadGMap()
{
	CreateHTMLSectionForGMap();
	GetMapData();
}

function LoadGearth()
{
	CreateHTMLSectionForGEarth();
	GetearthData();
}

function CreateHTMLSectionForGMap(){
//	debugger;
	var divs = '<div id="main">'
//		+ '<div id="estMapHeader" style="width:100%; height: 30px; cursor:pointer; vertical-align:middle">Click here to see seed area on google map</div>'
		+ '<div id="estMap" style="width:100%; height: 600px" title="Google estMap showing work estimation"></div>'
//		+'<div id="progressMapHeader" style="width:100%; height: 30px; cursor:pointer; vertical-align:middle">GPS Points/Map after Work Execution</div>'
//		+'<div id="progressMap" style="width:100%; height: 380px" title="Google estMap showing work progress"></div>'
//		+'<div id="progressEstMapHeader" style="width:100%; height: 30px; cursor:pointer; vertical-align:middle">Comparison of GPS Point/Map between estimation points and after work execution</div>'
//		+'<div id="progressEstMap" style="width:100%; height: 380px" title="Google estMap showing work progress"></div>'
		+'</div>';

	$('#mapMain').html(divs);
	$('#mapMain').find('#main').find('span').show();
	$('#estMapHeader').click(function(){
		if($('#estMap').is(':visible')){
			$('#estMap').slideUp(700)
		}
		else{
			$('#estMap').slideDown(700)                
		}
		// $('#progressMap,#progressEstMap').hide();
	});

//	$('#progressMapHeader').click(function(){
//	if($('#progressMap').is(':visible')){
//	$('#progressMap').slideUp(700)
//	}
//	else{
//	$('#progressMap').slideDown(700)                
//	}
//	$('#estMap,#progressEstMap').hide();
//	});

//	$('#progressEstMapHeader').click(function(){
//	if($('#progressEstMap').is(':visible')){
//	$('#progressEstMap').slideUp(700)
//	}
//	else{
//	$('#progressEstMap').slideDown(700)                
//	}
//	$('#estMap,#progressMap').hide();
//	});
}

function CreateHTMLSectionForGEarth(){
	// debugger;
	// $('#mapMain').append('<input type="checkbox" id="chkEstimation" value="Select" />Pole points estimated for project|<input id="chkProgress" type="checkbox" value="Select" />Poles updated During Execution');

	$('#mapMain').append('<div id="map"></div>');

	$('#map').css({'width' : '100%', 'height' : '700px'});

	$('#chkEstimation').bind('change',function(){
		//debugger;
		if($(this).attr('checked'))
		{
			ge.getFeatures().appendChild(kmlObjects.Estimated);
			//gex.util.flyToObject(kmlObjects.Estimated, { aspectRatio: 1 });
		}
		else
		{
			if(kmlObjects.Estimated!=null)
			{
				ge.getFeatures().removeChild(kmlObjects.Estimated);

			}
		}
	});


	$('#chkProgress').bind('change',function(){
		//alert($(this).attr('checked'));
		//debugger;
		if($(this).attr('checked'))
		{
			ge.getFeatures().appendChild(kmlObjects.Progress);
			//gex.util.flyToObject(kmlObjects.Progress, { aspectRatio: 1 });
		}
		else
		{
			if(kmlObjects.Progress!=null)
			{
				ge.getFeatures().removeChild(kmlObjects.Progress);
			}
		}
	});

}

function EnlargeImage(image)
{
	$(image).parent().parent().parent().find('.imageLarge').attr('src', $(image).attr('src'));
}


function LoadMap(data, mapDiv, lineColor, mapType) {

	var map = new GMap2(document.getElementById(mapDiv));

	map.setMapType(G_HYBRID_MAP);
	map.addControl(new GLargeMapControl());
	var arrayMarkers = [];
	var marker;var firstHeader='';
	var bounds = new GLatLngBounds();
	var startDist = 0;
	var interDist = 500;
	for (var i = 0; i < data.length; i++) {
		var startLatLng = new GLatLng(data[0].Latitude, data[0].Longitude)
		if(mapType=='progress'){
			marker = new GMarker(new GLatLng(data[i].Latitude, data[i].Longitude));
			bounds.extend(new GLatLng(data[i].Latitude, data[i].Longitude)); 
			// debugger;            
			var imeageWindowHTML = '';//'<table><tr><td>'+data[i].Photos[j].Caption+'</td></tr><tr><td>'+data[i].Latitude+'-'+data[i].Longitude+'</td></tr></table></ hr>';
			var firstImage = '';
			// <a href='" + strimgpath + "' rel='ajxlightbox'   ='" + dsPhotoDetails.Tables[1].Rows[i]["Caption"] + "' >
			if (data[i].Photos != null) {
				for (var j = 0; j < data[i].Photos.length; j++) {
					imeageWindowHTML += '<div class="divmarkerImage"><img onClick="EnlargeImage(this)" src="' + data[i].Photos[j].ImageURL + '" class="markerImage image" title="' + data[i].Photos[j].Caption + '" /></div>';
					//imeageWindowHTML += '<img onclick="EnlargeImage(this)" src="'+ data[i].Photos[j].ImageURL +'" class="image" title="'+data[i].Photos[j].Caption+'" />';
					if (firstImage == '') {
						firstHeader = data[i].Photos[j].Caption + '<hr />' + data[i].Latitude + '-' + data[i].Longitude
						firstImage = '<img src="' + data[i].Photos[j].ImageURL + '" class="imageLarge" title="' + data[i].Photos[j].Caption + '" />';
					}
				}
			}
			else {
				firstHeader =  data[i].Latitude + '-' + data[i].Longitude
			}
			imeageWindowHTML = firstHeader + '<hr />' + data[i].ChainageName + '<hr /><hr />' + data[i].StructureName + '<div class="divMain">'
			+'<div class="divLarge">'
			+firstImage
			+'</div>'
			+'<div class="divSmall">'
			+imeageWindowHTML
			+'<div class="divClose" onclick="ExpanCollapse(this)">'
			+'<img class="divClose" src="../Images/collapse.png">'
			+'</div>'
			+'</div>'
			+'</div>';
			marker = createMarker(new GLatLng(data[i].Latitude, data[i].Longitude), MarkerType.LTLine, imeageWindowHTML, 'click', data[i].componentId);                
			map.addOverlay(marker);
			if(i < data.length-1){
				arrayMarkers = [];
				if(data[i].iComponentGroupId==data[i+1].iComponentGroupId){
					if(data[i].iGroupComponentId==data[i+1].iGroupComponentId){
						arrayMarkers.push(new GLatLng(data[i].Latitude, data[i].Longitude));
						arrayMarkers.push(new GLatLng(data[i + 1].Latitude, data[i + 1].Longitude));
						if (data[i].iComponentGroupId == 1) {
							var polyline = new GPolyline(arrayMarkers, "GREEN", 6);
							//var polyline = new GPolyline(arrayMarkers, "RED", 3);
						}
						else
							var polyline = new GPolyline(arrayMarkers, "BLUE", 6);
						map.addOverlay(polyline);
					}}
			}

			if(i < data.length-1){
				arrayMarkers = [];
				if(data[i].iComponentGroupId==data[i+1].iComponentGroupId){
					if (data[i].iGroupComponentId == data[i + 1].iGroupComponentId) {

						var distance = google.maps.geometry.spherical
						.computeDistanceBetween(new GLatLng(data[i].Latitude, data[i].Longitude), new GLatLng(data[i + 1].Latitude, data[i + 1].Longitude));
						startDist = startDist + distance;
						var heading = google.maps.geometry.spherical
						.computeHeading(
								new GLatLng(data[i].Latitude, data[i].Longitude),
								new GLatLng(data[i + 1].Latitude, data[i + 1].Longitude));
						heading  = heading - 90;
						var startPolyine = google.maps.geometry.spherical
						.computeOffset(
								new GLatLng(data[i].Latitude, data[i].Longitude),
								30,
								heading);
						var endPolyine = google.maps.geometry.spherical
						.computeOffset(
								new GLatLng(data[i + 1].Latitude, data[i + 1].Longitude),
								30,
								heading);
						if (startDist <= interDist) {
							if (data[i].iComponentGroupId == 1) {
								var points  = [];
								var heading1 = google.maps.geometry.spherical
								.computeHeading(
										new GLatLng(data[i].Latitude, data[i].Longitude),
										new GLatLng(data[i + 1].Latitude, data[i + 1].Longitude));
								heading1  = heading1 + 90;
								var startPolyine1 = google.maps.geometry.spherical
								.computeOffset(
										new GLatLng(data[i].Latitude, data[i].Longitude),
										30,
										heading1);
								var endPolyine1 = google.maps.geometry.spherical
								.computeOffset(
										new GLatLng(data[i + 1].Latitude, data[i + 1].Longitude),
										30,
										heading1);
								points.push(startPolyine1);
								points.push(endPolyine1);
								var polyline = new GPolyline(points, "BLUE", 6);
								//var polyline = new GPolyline(arrayMarkers, "RED", 3);
							}
							//   else
								//     var polyline = new GPolyline(arrayMarkers, "ORANGE", 6);
						}
						arrayMarkers.push(startPolyine);
						arrayMarkers.push(endPolyine);
						if (data[i].iComponentGroupId == 1) {
							var polyline = new GPolyline(arrayMarkers, "RED", 6);
							//var polyline = new GPolyline(arrayMarkers, "RED", 3);
						}
						else
							var polyline = new GPolyline(arrayMarkers, "ORANGE", 6);
						map.addOverlay(polyline);
					}}
			}

			/*var heading = google.maps.geometry.spherical
					.computeHeading(
							newLatLng,
							endLatLng);
			//if ((startheading - heading) < 1) {
			var prevDist = newLatLng;
			console.log(heading);
			console.log('heading value');
			// get the latlng X miles from the starting point along this heading
			var newLatLng = google.maps.geometry.spherical
					.computeOffset(
							newLatLng,
							spanLength,
							heading);*/
			map.setCenter(bounds.getCenter());
			map.setZoom(map.getBoundsZoomLevel(bounds))
		}

	}

	$("div.divSmall").hide("fast");
}

function LoadCombMap(mapData,mapDiv)
{
	var markerOption;
	var map = new GMap2(document.getElementById(mapDiv));
	map.addControl(new GLargeMapControl());
	map.addControl(new GMapTypeControl());
	var arrayMarkers = [];
	var marker;
	var bounds = new GLatLngBounds();
	var data;
	var imeageWindowHTML = '';
	var firstImage = '';
	data = mapData.estimationCoordinate;

	for (var i = 0; i < data.length; i++) {  

		if(data[i].LineType==MarkerType.LTLine)
		{
			lineColor = "BLUE";
			markerOption = MarkerType.LTLine
		}
		else if (data[i].LineType==MarkerType.HTLine)
		{
			lineColor = "RED";
			markerOption = MarkerType.HTLine
		}
		else if (data[i].LineType==MarkerType.Transformer)
		{
			lineColor = "YELLOW";
			markerOption = MarkerType.Transformer
		}


		marker = new GMarker(new GLatLng(data[i].Latitude, data[i].Longitude));
		//Extending the map bound
		bounds.extend(new GLatLng(data[i].Latitude, data[i].Longitude));                
		//Creating a masrker with info ballon
		var imeageWindowHTML = '<div>';
		imeageWindowHTML += data[i].Caption+'<br /><hr>Distance : '+data[i].Distance+' meters.</div>';
		marker = createMarker(new GLatLng(data[i].Latitude, data[i].Longitude), MarkerType.LTLine, imeageWindowHTML,'mouseover',data[i].iPoletyperId);                
		map.addOverlay(marker);

		marker = new GMarker(new GLatLng(data[i].EstLatitude, data[i].EstLongitude));
		//Extending the map bound
		bounds.extend(new GLatLng(data[i].EstLatitude, data[i].EstLongitude));                
		//Creating a masrker with info ballon
		var imeageWindowHTML = '<div>';
		imeageWindowHTML += data[i].EndCaption+'<br /><hr>Distance : '+data[i].EndDistance+' meters.</div>';
		marker = createMarker(new GLatLng(data[i].EstLatitude, data[i].EstLongitude), markerOption, imeageWindowHTML,'mouseover',data[i].iPoletyperId);                
		map.addOverlay(marker);


		//creating a line to draw path
		arrayMarkers = [];
		arrayMarkers.push(new GLatLng(data[i].Latitude, data[i].Longitude));
		arrayMarkers.push(new GLatLng(data[i].EstLatitude, data[i].EstLongitude));
		var polyline = new GPolyline(arrayMarkers, lineColor,3);
		map.addOverlay(polyline, {labelContent : 'marker'});

	} 

	data = mapData.progressCoordinates;
	for (i = 0; i < data.length; i++) {  
		marker = new GMarker(new GLatLng(data[i].Latitude, data[i].Longitude));
		bounds.extend(new GLatLng(data[i].Latitude, data[i].Longitude)); 

		var imeageWindowHTML = '';
		var firstImage = '';
		//<a href='" + strimgpath + "' rel='ajxlightbox'   ='" + dsPhotoDetails.Tables[1].Rows[i]["Caption"] + "' >
		if(data[i].Photos!=null)
		{
			for(var j=0;j<data[i].Photos.length;j++){
				//imeageWindowHTML += '<div class="divmarkerImage"><img onClick="EnlargeImage(this)" src="'+ data[i].Photos[j].ImageURL +'" class="markerImage image" title="'+data[i].Photos[j].Caption+'" /></div>';
				imeageWindowHTML += '<img onclick="EnlargeImage(this)" src="'+ data[i].Photos[j].ImageURL +'" class="image" title="'+data[i].Photos[j].Caption+'" />';
				if(firstImage=='')
				{
					firstImage = '<img src="'+ data[i].Photos[j].ImageURL +'" class="imageLarge" title="'+data[i].Photos[j].Caption+'" />';
				}
			}
		}
		imeageWindowHTML = '<div class="divMain">'
			+'<div class="divLarge">'
			+firstImage
			+'</div>'
			+'<div class="divSmall">'
			+imeageWindowHTML
			+'<div class="divClose" onclick="ExpanCollapse(this)">'
			+'<img class="divClose" src="../Images/collapse.png">'
			+'</div>'
			+'</div>'
			+'</div>';
		marker = createMarker(new GLatLng(data[i].Latitude, data[i].Longitude), MarkerType.RedIcon, imeageWindowHTML,'click',data[i].iPoletyperId);                
		map.addOverlay(marker);
		debugger;
		if(i < data.length-1){
			arrayMarkers = [];
			if(data[i].iEstid==data[i+1].iEstid){
				if(data[i].iltestid==data[i+1].iltestid){
					arrayMarkers.push(new GLatLng(data[i].Latitude, data[i].Longitude)); 
					arrayMarkers.push(new GLatLng(data[i+1].Latitude, data[i+1].Longitude)); 
					var polyline = new GPolyline(arrayMarkers, "GREEN",3);
					map.addOverlay(polyline);}}
		}

	}
	map.setCenter(bounds.getCenter());
	map.setZoom(map.getBoundsZoomLevel(bounds))

}

function LoadCombinedMap(mapData,mapDiv){
	var map = new GMap2(document.getElementById(mapDiv));
	map.addControl(new GLargeMapControl());
	map.addControl(new GMapTypeControl());
	var arrayMarkersEst = [];
	var arrayMarkersProgress = [];
	var marker;
	var bounds = new GLatLngBounds();

	data = mapData.estimationCoordinate;
	for (var i = 0; i < data.length; i++) {  

		marker = new GMarker(new GLatLng(data[i].Latitude, data[i].Longitude));
		bounds.extend(new GLatLng(data[i].Latitude, data[i].Longitude));                
		marker = createMarker(new GLatLng(data[i].Latitude, data[i].Longitude), 'RED', '','click',1);                
		arrayMarkersEst.push(new GLatLng(data[i].Latitude, data[i].Longitude));
		map.addOverlay(marker);   
	}             

	data = mapData.progressCoordinates;
	for (var i = 0; i < data.length; i++) {  
		marker = new GMarker(new GLatLng(data[i].Latitude, data[i].Longitude));
		bounds.extend(new GLatLng(data[i].Latitude, data[i].Longitude)); 
		arrayMarkersProgress.push(new GLatLng(data[i].Latitude, data[i].Longitude));              
		marker = createMarker(new GLatLng(data[i].Latitude, data[i].Longitude), 'BLUE','','click',1);                
		map.addOverlay(marker);
	}
	var polylineEst = new GPolyline(arrayMarkersEst, 'RED',3);
	var polylineProgress = new GPolyline(arrayMarkersProgress, 'GREEN',3);
	map.addOverlay(polylineEst);  
	map.addOverlay(polylineProgress);  
	map.setCenter(bounds.getCenter());
	map.setZoom(map.getBoundsZoomLevel(bounds))
}


function createMarker(point, markerType, html, hoverEvents,iPoleType) {

	//http://thydzik.com/thydzikGoogleMap/markerlink.php?text=1&color=5680FC
	//Red: FC6355 Teal: 55D7D7 Yellow: FCF356 Purple: 7D54FC Pink: E14E9D Orange: EF9D3F Black: 000000 Brown: 9E7151 Gray: A8A8A8 Dark blue: 0336D1 White: ffffff
	//
	//http://chart.apis.google.com/chart?chst=d_map_pin_letter_withshadow chld=A|FF0000|0000FF
//	/////Arun Created For Markers
//	var blueIcon = new GIcon(G_DEFAULT_ICON);
//	blueIcon.image = "http://www.google.com/intl/en_us/mapfiles/ms/micons/blue-dot.png";

	var redIcon = new GIcon(G_DEFAULT_ICON);
	redIcon.image = "http://www.google.com/intl/en_us/mapfiles/ms/micons/red-dot.png";

//	var greenIcon = new GIcon(G_DEFAULT_ICON);
//	greenIcon.image = "http://www.google.com/intl/en_us/mapfiles/ms/micons/green-dot.png";

//	var yellowIcon = new GIcon(G_DEFAULT_ICON);
//	yellowIcon.image = "http://www.google.com/intl/en_us/mapfiles/ms/micons/yellow-dot.png";

//	var poleIcon = new GIcon(G_DEFAULT_ICON);
//	poleIcon.image = "/Images/MapIcons/pole.png";

//	var transformerIcon = new GIcon(G_DEFAULT_ICON);
//	transformerIcon.image = "/Images/MapIcons/transformer.png";

//	var markerOptions;
//	switch(markerType)
//	{
//	case MarkerType.LTLine : 
//	markerOptions = { icon: poleIcon, title: html, labelContent : 'marker'}
//	break;
//	case MarkerType.HTLine : 
//	markerOptions = { icon: poleIcon, title: html, labelContent : 'marker'}
//	break;
//	case MarkerType.Transformer : 
//	markerOptions = { icon: poleIcon, title: html, labelContent : 'marker'}
//	break;
//	case MarkerType.GreenIcon : 
//	markerOptions = { icon: greenIcon, title: html, labelContent : 'marker'}
//	break;
//	case MarkerType.BlueIcon :
//	markerOptions = { icon: blueIcon, title: html, labelContent : 'marker'}
//	break;
//	case MarkerType.RedIcon :
//	markerOptions = { icon: redIcon, title: html, labelContent : 'marker'}
//	break;
//	case MarkerType.YellowIcon :
//	markerOptions = { icon: yellowIcon, title: html, labelContent : 'marker'}
//	break;
//	}
	//var markerOptions = color == 'BLUE' ? { icon: blueIcon, title: html} : (color == 'GREEN' ? { icon: greenIcon, title: html} : (color == 'YELLOW' ? { icon: yellowIcon, title: html} : { icon: redIcon, title: html }));
	var PointIcon = new GIcon(G_DEFAULT_ICON);
	PointIcon.image = "/Images/pole.png";
	//PointIcon.image = "http://maps.google.com/mapfiles/kml/pal4/icon49.png";
//	PointIcon.shadow="";
//	var markerOptions;
//	switch(iPoleType)
//	{
//	case 1:
//	PointIcon.image = "/Images/MapIcons/pole.png";
//	break;
//	case 2:
//	PointIcon.image = "/Images/MapIcons/transformer.png";
//	break;
//	case 3:
//	PointIcon.image = "/Images/MapIcons/DPSet.png";
//	break;
//	case 4:
//	PointIcon.image = "/Images/MapIcons/Tapping.png";
//	break;
//	case 5:
//	PointIcon.image = "/Images/MapIcons/pole.png";
//	break;
	//            }
	if (iPoleType == 3) {
		markerOptions = { icon: redIcon, title: html, labelContent: 'marker' };
	} else {
		markerOptions = { icon: PointIcon, title: html, labelContent: 'marker' };
	}
	var marker = new GMarker(point, markerOptions);
	//markersCollection.push(marker);
	if(html!=''){
		GEvent.addListener(marker, hoverEvents, function () {
			//alert(html);
			marker.openInfoWindowHtml(html);
		});


		GEvent.addListener(marker, 'infowindowclose', function () {
			$('#largeImage').hide().find('img').attr('src', '');
		})
	}



	return marker;
}

function createMarkerWithOptions(point, markerOptions, InfoWindowEvent) {

	var marker = new GMarker(point, markerOptions);
	if(markerOptions.title!=''){
		GEvent.addListener(marker, hoverEvents, function () {
			//alert(html);
			marker.openInfoWindowHtml(html);
		});

		GEvent.addListener(marker, 'infowindowclose', function () {
			$('#largeImage').hide().find('img').attr('src', '');
		})
	}
	return marker;
}

function GetMapData(){
	$.ajax({
		type: 'POST',
		url: '/PWMT/GoogleMap.aspx/GetWorkDeatilsForMap',
		data: "{'iWorkRowid':"+$('#hdnWorkId').attr('value')+"}",
		contentType: 'application/json; charset=utf-8',
		dataType: 'json',
		success: function (data) {

			LoadMap(data.d.ProgressCoordinates, 'estMap', 'RED', 'progress')
//			LoadMap(data.progressCoordinates,'progressMap','GREEN','progress')
//			LoadCombMap(data,'progressEstMap')
			// $('#mapMain').find('#main').find('span').hide();
		},
		error: function (errData) {
			alert(errData.responseText);
			//   $('div').html(errData.responseText);
		},
		complete: function(){
			// $('#estMap,#progressMap,#progressEstMap').hide();
		}
	});

}



function init() {
	$('#map').css({'width' : '100%', 'height' : '700px'});
	var isGEInstalled = google.earth.isInstalled();
	if($('#hid_earthMap').val()=="2")
	{
		//Load Google earth
		CreateHTMLSectionForGEarth();
		google.earth.createInstance('map', initCB, failureCB);
	}
	else
	{
		//Load simple map
		LoadGMap();
		//ShowError('Please install Google earth for better experience. ' + '<a href="http://www.google.com/earth/index.html" target="_blank">Click here</a> to download and install Google earth Plugin.')
	}
}

function initCB(instance) {
	ge = instance;
	ge.getWindow().setVisibility(true);
	ge.getNavigationControl().setVisibility(ge.VISIBILITY_AUTO);
	ge.getLayerRoot().enableLayerById(ge.LAYER_BORDERS, true);
	ge.getLayerRoot().enableLayerById(ge.LAYER_BUILDINGS, true);
	gex = new GEarthExtensions(ge);
	GetearthData();

}

function failureCB(errorCode) {
//	http://www.google.com/earth/index.html

}

function GetearthData()
{
	ge.getWindow().setVisibility(true);
	$.ajax({
		type: 'POST',
		url: '/Gescom/GMap.aspx/GetWorkDeatilsForEarth',
		data: "{'iWorkRowid':"+$('#hdnWorkId').attr('value')+"}",
		contentType: 'application/json; charset=utf-8',
		dataType: 'json',
		success: function (data) {
			try{
				kmlObjects.Estimated = ge.parseKml(data[0]);
				kmlObjects.Progress = ge.parseKml(data[1]);
				$('#chkEstimation').attr('checked','checked');
				ge.getFeatures().appendChild(kmlObjects.Estimated);
				//ge.getView().setAbstractView(kmlObjects.Estimated.getAbstractView())
				//ge.getFeatures().appendChild(kmlObjects.Progress);
				//ge.getView().setAbstractView(kmlObjects.Progress.getAbstractView())
				gex.util.flyToObject(kmlObjects.Estimated, { aspectRatio: 1 });
			}
			catch(e)
			{
				var errorText = 'Message : ' + e.message 
				+ ' Description : ' + e.description
				+ ' Number : ' + e.number
				+ ' Name : ' + e.name;
				ShowError(errorText);
				return;
			}
		},
		error: function (errData) {
			alert(errData.responseText);
			//   $('div').html(errData.responseText);
		},
		complete: function(){
			$('#estMap,#progressMap,#progressEstMap').hide();
		}
	});

}

function ShowError(errorText)
{
	$('#diverror').html(errorText).slideDown();
}

function HideError()
{
	$('#diverror').hide();
}
function GetMarkerWithLabel(map, labelContent){
	var marker = new MarkerWithLabel({
		position: new google.maps.LatLng(0,0),
		draggable: false,
		raiseOnDrag: false,
		map: map,
		labelContent: labelContent,
		labelAnchor: new google.maps.Point(30, 20),
		labelClass: "labels", // the CSS class for the label
		labelStyle: {opacity: 1.0},
		visible: false
	});

}
